# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.volume_mapper import VolumeMapper


class AMRVolumeMapper(VolumeMapper):
    """
    AMRVolumeMapper - AMR class for a volume mapper
    
    Superclass: VolumeMapper
    
    AMRVolumeMapper is the  definition of a volume mapper. for AMR
    Structured Data
    
    See Also:
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkAMRVolumeMapper, obj, update, **traits)
    
    requested_render_mode = traits.Trait('default',
    tvtk_base.TraitRevPrefixMap({'default': 0, 'gpu': 4, 'ray_cast_and_texture': 1, 'texture': 3, 'ray_cast': 2}), help=\
        """
        Set the requested render mode. The default is
        SmartVolumeMapper::DefaultRenderMode.
        """
    )

    def _requested_render_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRequestedRenderMode,
                        self.requested_render_mode_)

    interpolation_mode = traits.Trait('cubic',
    tvtk_base.TraitRevPrefixMap({'nearest_neighbor': 0, 'linear': 1, 'cubic': 2}), help=\
        """
        Set interpolation mode for downsampling (lowres GPU) (initial
        value: cubic).
        """
    )

    def _interpolation_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetInterpolationMode,
                        self.interpolation_mode_)

    use_default_threading = traits.Bool(False, auto_set=False, enter_set=True, help=\
        """
        Sets/Gets a flag that indicates the internal volume mapper should
        use the  default number of threads.  This is useful in
        applications such as para_view that will turn off multiple threads
        by default. Default is false
        """
    )

    def _use_default_threading_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseDefaultThreading,
                        self.use_default_threading)

    requested_resampling_mode = traits.Int(0, auto_set=False, enter_set=True, help=\
        """
        Select the type of resampling techinque approach to use.
        """
    )

    def _requested_resampling_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRequestedResamplingMode,
                        self.requested_resampling_mode)

    number_of_samples = traits.Array(auto_set=False, enter_set=True, shape=(3,), dtype=int, value=(128, 128, 128), cols=3, help=\
        """
        
        """
    )

    def _number_of_samples_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfSamples,
                        self.number_of_samples)

    cropping_region_planes = traits.Array(auto_set=False, enter_set=True, shape=(6,), dtype=float, value=(0.0, 1.0, 0.0, 1.0, 0.0, 1.0), cols=3, help=\
        """
        Set/Get the Cropping Region Planes ( xmin, xmax, ymin, ymax,
        zmin, zmax ) These planes are defined in volume coordinates -
        spacing and origin are considered.
        """
    )

    def _cropping_region_planes_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCroppingRegionPlanes,
                        self.cropping_region_planes)

    blend_mode = traits.Int(0, auto_set=False, enter_set=True, help=\
        """
        Set/Get the blend mode. Currently this is only supported by the
        FixedPointVolumeRayCastMapper - other mappers have different
        ways to set this (supplying a function to a
        VolumeRayCastMapper) or don't have any options
        (vtk_volume_texture_mapper2d supports only compositing). Additive
        blend mode adds scalars along the ray and multiply them by their
        opacity mapping value.
        """
    )

    def _blend_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBlendMode,
                        self.blend_mode)

    resampler_update_tolerance = traits.Float(1e-07, auto_set=False, enter_set=True, help=\
        """
        Sets/Gets the tolerance used to determine if the resampler needs
        to be updated. Default is 10e-8
        """
    )

    def _resampler_update_tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetResamplerUpdateTolerance,
                        self.resampler_update_tolerance)

    cropping = traits.Int(0, auto_set=False, enter_set=True, help=\
        """
        Turn On/Off orthogonal cropping. (Clipping planes are
        perpendicular to the coordinate axes.)
        """
    )

    def _cropping_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCropping,
                        self.cropping)

    cropping_region_flags = traits.Int(8192, auto_set=False, enter_set=True, help=\
        """
        Set the flags for the cropping regions. The clipping planes
        divide the volume into 27 regions - there is one bit for each
        region. The regions start from the one containing voxel (0,0,0),
        moving along the x axis fastest, the y axis next, and the z axis
        slowest. These are represented from the lowest bit to bit number
        27 in the integer containing the flags. There are several
        convenience functions to set some common configurations -
        subvolume (the default), fence (between any of the clip plane
        pairs), inverted fence, cross (between any two of the clip plane
        pairs) and inverted cross.
        """
    )

    def _cropping_region_flags_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCroppingRegionFlags,
                        self.cropping_region_flags)

    freeze_focal_point = traits.Bool(False, auto_set=False, enter_set=True, help=\
        """
        Select the type of resampling techinque approach to use.
        """
    )

    def _freeze_focal_point_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetFreezeFocalPoint,
                        self.freeze_focal_point)

    def compute_resampler_bounds_frustum_method(self, *args):
        """
        V.compute_resampler_bounds_frustum_method(Camera, Renderer, (
            float, float, float, float, float, float), [float, float,
            float, float, float, float]) -> bool
        C++: static bool ComputeResamplerBoundsFrustumMethod(
            Camera *camera, Renderer *renderer,
            const double data_bounds[6], double out_bounds[6])
        Utility method used by update_resampler_frustrum_method() to compute
        the bounds.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.ComputeResamplerBoundsFrustumMethod, *my_args)
        return ret

    def update_resampler(self, *args):
        """
        V.update_resampler(Renderer, OverlappingAMR)
        C++: void UpdateResampler(Renderer *ren,
            OverlappingAMR *amr)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.UpdateResampler, *my_args)
        return ret

    def update_resampler_frustrum_method(self, *args):
        """
        V.update_resampler_frustrum_method(Renderer, OverlappingAMR)
        C++: void UpdateResamplerFrustrumMethod(Renderer *ren,
            OverlappingAMR *amr)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.UpdateResamplerFrustrumMethod, *my_args)
        return ret

    _updateable_traits_ = \
    (('number_of_samples', 'GetNumberOfSamples'),
    ('cropping_region_flags', 'GetCroppingRegionFlags'), ('scalar_mode',
    'GetScalarMode'), ('use_default_threading', 'GetUseDefaultThreading'),
    ('resampler_update_tolerance', 'GetResamplerUpdateTolerance'),
    ('requested_resampling_mode', 'GetRequestedResamplingMode'),
    ('blend_mode', 'GetBlendMode'), ('reference_count',
    'GetReferenceCount'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('requested_render_mode',
    'GetRequestedRenderMode'), ('progress_text', 'GetProgressText'),
    ('abort_execute', 'GetAbortExecute'), ('cropping_region_planes',
    'GetCroppingRegionPlanes'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'), ('progress',
    'GetProgress'), ('cropping', 'GetCropping'), ('freeze_focal_point',
    'GetFreezeFocalPoint'), ('interpolation_mode',
    'GetInterpolationMode'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'cropping', 'debug', 'global_warning_display',
    'release_data_flag', 'blend_mode', 'cropping_region_flags',
    'interpolation_mode', 'requested_render_mode', 'scalar_mode',
    'blend_mode', 'cropping', 'cropping_region_flags',
    'cropping_region_planes', 'freeze_focal_point', 'number_of_samples',
    'progress_text', 'requested_resampling_mode',
    'resampler_update_tolerance', 'use_default_threading'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(AMRVolumeMapper, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit AMRVolumeMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['cropping'], ['blend_mode', 'cropping_region_flags',
            'interpolation_mode', 'requested_render_mode', 'scalar_mode'],
            ['blend_mode', 'cropping', 'cropping_region_flags',
            'cropping_region_planes', 'freeze_focal_point', 'number_of_samples',
            'requested_resampling_mode', 'resampler_update_tolerance',
            'use_default_threading']),
            title='Edit AMRVolumeMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit AMRVolumeMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

