# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.multi_block_plot3d_reader import MultiBlockPLOT3DReader


class MPIMultiBlockPLOT3DReader(MultiBlockPLOT3DReader):
    """
    MPIMultiBlockPLOT3DReader - MultiBlockPLOT3DReader subclass that
    
    Superclass: MultiBlockPLOT3DReader
    
    MPIMultiBlockPLOT3DReader extends MultiBlockPLOT3DReader to use
    MPI-IO instead of POSIX IO to read file in parallel.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkMPIMultiBlockPLOT3DReader, obj, update, **traits)
    
    use_mpiio = tvtk_base.true_bool_trait(help=\
        """
        Use this to override using MPI-IO. When set to false (default is
        true), this class will simply forward all method calls to the
        superclass.
        """
    )

    def _use_mpiio_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseMPIIO,
                        self.use_mpiio_)

    _updateable_traits_ = \
    (('byte_order', 'GetByteOrder'), ('force_read', 'GetForceRead'),
    ('binary_file', 'GetBinaryFile'), ('use_mpiio', 'GetUseMPIIO'),
    ('file_name', 'GetFileName'), ('r', 'GetR'),
    ('two_dimensional_geometry', 'GetTwoDimensionalGeometry'),
    ('reference_count', 'GetReferenceCount'), ('vector_function_number',
    'GetVectorFunctionNumber'), ('function_file_name',
    'GetFunctionFileName'), ('i_blanking', 'GetIBlanking'),
    ('auto_detect_format', 'GetAutoDetectFormat'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('q_file_name',
    'GetQFileName'), ('multi_grid', 'GetMultiGrid'), ('xyz_file_name',
    'GetXYZFileName'), ('has_byte_count', 'GetHasByteCount'),
    ('progress_text', 'GetProgressText'), ('double_precision',
    'GetDoublePrecision'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'),
    ('scalar_function_number', 'GetScalarFunctionNumber'), ('debug',
    'GetDebug'), ('progress', 'GetProgress'), ('gamma', 'GetGamma'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'auto_detect_format', 'binary_file', 'debug',
    'double_precision', 'force_read', 'global_warning_display',
    'has_byte_count', 'i_blanking', 'multi_grid', 'release_data_flag',
    'two_dimensional_geometry', 'use_mpiio', 'byte_order', 'file_name',
    'function_file_name', 'gamma', 'progress_text', 'q_file_name', 'r',
    'scalar_function_number', 'vector_function_number', 'xyz_file_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(MPIMultiBlockPLOT3DReader, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit MPIMultiBlockPLOT3DReader properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['auto_detect_format', 'binary_file', 'double_precision',
            'force_read', 'has_byte_count', 'i_blanking', 'multi_grid',
            'two_dimensional_geometry', 'use_mpiio'], ['byte_order'],
            ['file_name', 'function_file_name', 'gamma', 'q_file_name', 'r',
            'scalar_function_number', 'vector_function_number', 'xyz_file_name']),
            title='Edit MPIMultiBlockPLOT3DReader properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit MPIMultiBlockPLOT3DReader properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

